; Formal verification proof - functional equivalence checking of test_netlist_20+10x10MAC.txt
(set-logic QF_BV)

; Inputs: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, y0, y1, y2, y3, y4, y5, y6, y7, y8, y9
(declare-fun x0 () (_ BitVec 1))
(declare-fun x1 () (_ BitVec 1))
(declare-fun x2 () (_ BitVec 1))
(declare-fun x3 () (_ BitVec 1))
(declare-fun x4 () (_ BitVec 1))
(declare-fun x5 () (_ BitVec 1))
(declare-fun x6 () (_ BitVec 1))
(declare-fun x7 () (_ BitVec 1))
(declare-fun x8 () (_ BitVec 1))
(declare-fun x9 () (_ BitVec 1))
(declare-fun y0 () (_ BitVec 1))
(declare-fun y1 () (_ BitVec 1))
(declare-fun y2 () (_ BitVec 1))
(declare-fun y3 () (_ BitVec 1))
(declare-fun y4 () (_ BitVec 1))
(declare-fun y5 () (_ BitVec 1))
(declare-fun y6 () (_ BitVec 1))
(declare-fun y7 () (_ BitVec 1))
(declare-fun y8 () (_ BitVec 1))
(declare-fun y9 () (_ BitVec 1))

; Initial register output states of: a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19
(declare-fun a0 () (_ BitVec 1))
(declare-fun a1 () (_ BitVec 1))
(declare-fun a2 () (_ BitVec 1))
(declare-fun a3 () (_ BitVec 1))
(declare-fun a4 () (_ BitVec 1))
(declare-fun a5 () (_ BitVec 1))
(declare-fun a6 () (_ BitVec 1))
(declare-fun a7 () (_ BitVec 1))
(declare-fun a8 () (_ BitVec 1))
(declare-fun a9 () (_ BitVec 1))
(declare-fun a10 () (_ BitVec 1))
(declare-fun a11 () (_ BitVec 1))
(declare-fun a12 () (_ BitVec 1))
(declare-fun a13 () (_ BitVec 1))
(declare-fun a14 () (_ BitVec 1))
(declare-fun a15 () (_ BitVec 1))
(declare-fun a16 () (_ BitVec 1))
(declare-fun a17 () (_ BitVec 1))
(declare-fun a18 () (_ BitVec 1))
(declare-fun a19 () (_ BitVec 1))

(declare-fun reset () (_ BitVec 1))
(declare-fun A_cs () (_ BitVec 20))


(define-fun bvRegD ((a (_ BitVec 1 )) (reset (_ BitVec 1))) (_ BitVec 1)						
 (ite (= reset (_ bv1 1)) (_ bv0 1) a) )


(define-fun bvha_sum ((a (_ BitVec 1 )) (b (_ BitVec 1 ))) (_ BitVec 1)						
 (bvxor a b) )

(define-fun bvha_carry ((a (_ BitVec 1 )) (b (_ BitVec 1 ))) (_ BitVec 1)						
 (bvand a b) )


(define-fun bvfa_sum ((a (_ BitVec 1 )) (b (_ BitVec 1 )) (cin (_ BitVec 1 )) ) (_ BitVec 1)						
 (bvxor a (bvxor b cin)) )

(define-fun bvfa_carry ((a (_ BitVec 1 )) (b (_ BitVec 1 )) (cin (_ BitVec 1 )) ) (_ BitVec 1)						
 (bvor (bvand a b) (bvor (bvand b cin) (bvand a cin)))  )

; SAT/UNSAT assertion for test_netlist_20+10x10MAC.txt
(assert
	(not		
		(let
			(
				(p0 (bvand x0 y0))
				(t0 (bvand x1 y0))
				(t1 (bvand x0 y1))
				(t2 (bvand x2 y0))
				(t3 (bvand x1 y1))
				(t7 (bvand x3 y0))
				(t8 (bvand x2 y1))
				(t12 (bvand x4 y0))
				(t13 (bvand x3 y1))
				(t17 (bvand x5 y0))
				(t18 (bvand x4 y1))
				(t22 (bvand x6 y0))
				(t23 (bvand x5 y1))
				(t27 (bvand x7 y0))
				(t28 (bvand x6 y1))
				(t32 (bvand x8 y0))
				(t33 (bvand x7 y1))
				(t37 (bvand x9 y0))
				(t38 (bvand x8 y1))
				(t42 (bvand x9 y1))
				(t43 (bvand x0 y2))
				(t44 (bvand x1 y2))
				(t48 (bvand x2 y2))
				(t52 (bvand x3 y2))
				(t56 (bvand x4 y2))
				(t60 (bvand x5 y2))
				(t64 (bvand x6 y2))
				(t68 (bvand x7 y2))
				(t72 (bvand x8 y2))
				(t76 (bvand x9 y2))
				(t80 (bvand x0 y3))
				(t81 (bvand x1 y3))
				(t85 (bvand x2 y3))
				(t89 (bvand x3 y3))
				(t93 (bvand x4 y3))
				(t97 (bvand x5 y3))
				(t101 (bvand x6 y3))
				(t105 (bvand x7 y3))
				(t109 (bvand x8 y3))
				(t113 (bvand x9 y3))
				(t117 (bvand x0 y4))
				(t118 (bvand x1 y4))
				(t122 (bvand x2 y4))
				(t126 (bvand x3 y4))
				(t130 (bvand x4 y4))
				(t134 (bvand x5 y4))
				(t138 (bvand x6 y4))
				(t142 (bvand x7 y4))
				(t146 (bvand x8 y4))
				(t150 (bvand x9 y4))
				(t154 (bvand x0 y5))
				(t155 (bvand x1 y5))
				(t159 (bvand x2 y5))
				(t163 (bvand x3 y5))
				(t167 (bvand x4 y5))
				(t171 (bvand x5 y5))
				(t175 (bvand x6 y5))
				(t179 (bvand x7 y5))
				(t183 (bvand x8 y5))
				(t187 (bvand x9 y5))
				(t191 (bvand x0 y6))
				(t192 (bvand x1 y6))
				(t196 (bvand x2 y6))
				(t200 (bvand x3 y6))
				(t204 (bvand x4 y6))
				(t208 (bvand x5 y6))
				(t212 (bvand x6 y6))
				(t216 (bvand x7 y6))
				(t220 (bvand x8 y6))
				(t224 (bvand x9 y6))
				(t228 (bvand x0 y7))
				(t229 (bvand x1 y7))
				(t233 (bvand x2 y7))
				(t237 (bvand x3 y7))
				(t241 (bvand x4 y7))
				(t245 (bvand x5 y7))
				(t249 (bvand x6 y7))
				(t253 (bvand x7 y7))
				(t257 (bvand x8 y7))
				(t261 (bvand x9 y7))
				(t265 (bvand x0 y8))
				(t266 (bvand x1 y8))
				(t270 (bvand x2 y8))
				(t274 (bvand x3 y8))
				(t278 (bvand x4 y8))
				(t282 (bvand x5 y8))
				(t286 (bvand x6 y8))
				(t290 (bvand x7 y8))
				(t294 (bvand x8 y8))
				(t298 (bvand x9 y8))
				(t302 (bvand x0 y9))
				(t303 (bvand x1 y9))
				(t307 (bvand x2 y9))
				(t311 (bvand x3 y9))
				(t315 (bvand x4 y9))
				(t319 (bvand x5 y9))
				(t323 (bvand x6 y9))
				(t327 (bvand x7 y9))
				(t331 (bvand x8 y9))
				(t335 (bvand x9 y9))
			)		
		(let
			(
				(p1 (bvxor t0 t1))
				(c0 (bvand t0 t1))
				(t4 (bvxor t2 t3))
				(t6 (bvand t2 t3))
				(t9 (bvxor t7 t8))
				(t10 (bvand t7 t8))
				(t14 (bvxor t12 t13))
				(t15 (bvand t12 t13))
				(t19 (bvxor t17 t18))
				(t20 (bvand t17 t18))
				(t24 (bvxor t22 t23))
				(t25 (bvand t22 t23))
				(t29 (bvxor t27 t28))
				(t30 (bvand t27 t28))
				(t34 (bvxor t32 t33))
				(t35 (bvand t32 t33))
				(t39 (bvxor t37 t38))
				(t40 (bvand t37 t38))
				(m0 (bvha_sum p0 a0))
				(c90 (bvha_carry p0 a0))
			)		
		(let
			(
				(s1 (bvxor c0 t4))
				(t5 (bvand c0 t4))
				(m1 (bvfa_sum p1 a1 c90))
				(c91 (bvfa_carry p1 a1 c90))
			)		
		(let
			(
				(c1 (bvor t6 t5))
				(p2 (bvxor s1 t43))
				(c10 (bvand s1 t43))
			)		
		(let
			(
				(s2 (bvxor c1 t9))
				(t11 (bvand c1 t9))
				(m2 (bvfa_sum p2 a2 c91))
				(c92 (bvfa_carry p2 a2 c91))
			)		
		(let
			(
				(c2 (bvor t10 t11))
				(t45 (bvxor s2 t44))
				(t46 (bvand s2 t44))
			)		
		(let
			(
				(s3 (bvxor c2 t14))
				(t16 (bvand c2 t14))
				(s10 (bvxor c10 t45))
				(t47 (bvand c10 t45))
			)		
		(let
			(
				(c3 (bvor t15 t16))
				(c11 (bvor t47 t46))
				(t49 (bvxor s3 t48))
				(t50 (bvand s3 t48))
				(p3 (bvxor s10 t80))
				(c20 (bvand s10 t80))
			)		
		(let
			(
				(s4 (bvxor c3 t19))
				(t21 (bvand c3 t19))
				(s11 (bvxor c11 t49))
				(t51 (bvand c11 t49))
				(m3 (bvfa_sum p3 a3 c92))
				(c93 (bvfa_carry p3 a3 c92))
			)		
		(let
			(
				(c4 (bvor t21 t20))
				(c12 (bvor t51 t50))
				(t53 (bvxor s4 t52))
				(t54 (bvand s4 t52))
				(t82 (bvxor s11 t81))
				(t83 (bvand s11 t81))
			)		
		(let
			(
				(s5 (bvxor c4 t24))
				(t26 (bvand c4 t24))
				(s12 (bvxor c12 t53))
				(t55 (bvand c12 t53))
				(s19 (bvxor c20 t82))
				(t84 (bvand c20 t82))
			)		
		(let
			(
				(c5 (bvor t25 t26))
				(c13 (bvor t55 t54))
				(t57 (bvxor s5 t56))
				(t58 (bvand s5 t56))
				(c21 (bvor t84 t83))
				(t86 (bvxor s12 t85))
				(t87 (bvand s12 t85))
				(p4 (bvxor s19 t117))
				(c30 (bvand s19 t117))
			)		
		(let
			(
				(s6 (bvxor c5 t29))
				(t31 (bvand c5 t29))
				(s13 (bvxor c13 t57))
				(t59 (bvand c13 t57))
				(s20 (bvxor c21 t86))
				(t88 (bvand c21 t86))
				(m4 (bvfa_sum p4 a4 c93))
				(c94 (bvfa_carry p4 a4 c93))
			)		
		(let
			(
				(c6 (bvor t30 t31))
				(c14 (bvor t59 t58))
				(t61 (bvxor s6 t60))
				(t62 (bvand s6 t60))
				(c22 (bvor t88 t87))
				(t90 (bvxor s13 t89))
				(t91 (bvand s13 t89))
				(t119 (bvxor s20 t118))
				(t120 (bvand s20 t118))
			)		
		(let
			(
				(s7 (bvxor c6 t34))
				(t36 (bvand c6 t34))
				(s14 (bvxor c14 t61))
				(t63 (bvand c14 t61))
				(s21 (bvxor c22 t90))
				(t92 (bvand c22 t90))
				(s28 (bvxor c30 t119))
				(t121 (bvand c30 t119))
			)		
		(let
			(
				(c7 (bvor t35 t36))
				(c15 (bvor t63 t62))
				(t65 (bvxor s7 t64))
				(t66 (bvand s7 t64))
				(c23 (bvor t92 t91))
				(t94 (bvxor s14 t93))
				(t95 (bvand s14 t93))
				(c31 (bvor t121 t120))
				(t123 (bvxor s21 t122))
				(t124 (bvand s21 t122))
				(p5 (bvxor s28 t154))
				(c40 (bvand s28 t154))
			)		
		(let
			(
				(s8 (bvxor c7 t39))
				(t41 (bvand c7 t39))
				(s15 (bvxor c15 t65))
				(t67 (bvand c15 t65))
				(s22 (bvxor c23 t94))
				(t96 (bvand c23 t94))
				(s29 (bvxor c31 t123))
				(t125 (bvand c31 t123))
				(m5 (bvfa_sum p5 a5 c94))
				(c95 (bvfa_carry p5 a5 c94))
			)		
		(let
			(
				(c8 (bvor t41 t40))
				(c16 (bvor t67 t66))
				(t69 (bvxor s8 t68))
				(t70 (bvand s8 t68))
				(c24 (bvor t96 t95))
				(t98 (bvxor s15 t97))
				(t99 (bvand s15 t97))
				(c32 (bvor t125 t124))
				(t127 (bvxor s22 t126))
				(t128 (bvand s22 t126))
				(t156 (bvxor s29 t155))
				(t157 (bvand s29 t155))
			)		
		(let
			(
				(s9 (bvxor c8 t42))
				(c9 (bvand c8 t42))
				(s16 (bvxor c16 t69))
				(t71 (bvand c16 t69))
				(s23 (bvxor c24 t98))
				(t100 (bvand c24 t98))
				(s30 (bvxor c32 t127))
				(t129 (bvand c32 t127))
				(s37 (bvxor c40 t156))
				(t158 (bvand c40 t156))
			)		
		(let
			(
				(c17 (bvor t71 t70))
				(t73 (bvxor s9 t72))
				(t74 (bvand s9 t72))
				(c25 (bvor t100 t99))
				(t102 (bvxor s16 t101))
				(t103 (bvand s16 t101))
				(c33 (bvor t129 t128))
				(t131 (bvxor s23 t130))
				(t132 (bvand s23 t130))
				(c41 (bvor t158 t157))
				(t160 (bvxor s30 t159))
				(t161 (bvand s30 t159))
				(p6 (bvxor s37 t191))
				(c50 (bvand s37 t191))
			)		
		(let
			(
				(s17 (bvxor c17 t73))
				(t75 (bvand c17 t73))
				(s24 (bvxor c25 t102))
				(t104 (bvand c25 t102))
				(s31 (bvxor c33 t131))
				(t133 (bvand c33 t131))
				(s38 (bvxor c41 t160))
				(t162 (bvand c41 t160))
				(m6 (bvfa_sum p6 a6 c95))
				(c96 (bvfa_carry p6 a6 c95))
			)		
		(let
			(
				(c18 (bvor t75 t74))
				(t77 (bvxor c9 t76))
				(t78 (bvand c9 t76))
				(c26 (bvor t104 t103))
				(t106 (bvxor s17 t105))
				(t107 (bvand s17 t105))
				(c34 (bvor t133 t132))
				(t135 (bvxor s24 t134))
				(t136 (bvand s24 t134))
				(c42 (bvor t162 t161))
				(t164 (bvxor s31 t163))
				(t165 (bvand s31 t163))
				(t193 (bvxor s38 t192))
				(t194 (bvand s38 t192))
			)		
		(let
			(
				(s18 (bvxor c18 t77))
				(t79 (bvand c18 t77))
				(s25 (bvxor c26 t106))
				(t108 (bvand c26 t106))
				(s32 (bvxor c34 t135))
				(t137 (bvand c34 t135))
				(s39 (bvxor c42 t164))
				(t166 (bvand c42 t164))
				(s46 (bvxor c50 t193))
				(t195 (bvand c50 t193))
			)		
		(let
			(
				(c19 (bvor t79 t78))
				(c27 (bvor t108 t107))
				(t110 (bvxor s18 t109))
				(t111 (bvand s18 t109))
				(c35 (bvor t137 t136))
				(t139 (bvxor s25 t138))
				(t140 (bvand s25 t138))
				(c43 (bvor t166 t165))
				(t168 (bvxor s32 t167))
				(t169 (bvand s32 t167))
				(c51 (bvor t195 t194))
				(t197 (bvxor s39 t196))
				(t198 (bvand s39 t196))
				(p7 (bvxor s46 t228))
				(c60 (bvand s46 t228))
			)		
		(let
			(
				(s26 (bvxor c27 t110))
				(t112 (bvand c27 t110))
				(t114 (bvxor c19 t113))
				(t115 (bvand c19 t113))
				(s33 (bvxor c35 t139))
				(t141 (bvand c35 t139))
				(s40 (bvxor c43 t168))
				(t170 (bvand c43 t168))
				(s47 (bvxor c51 t197))
				(t199 (bvand c51 t197))
				(m7 (bvfa_sum p7 a7 c96))
				(c97 (bvfa_carry p7 a7 c96))
			)		
		(let
			(
				(c28 (bvor t112 t111))
				(c36 (bvor t141 t140))
				(t143 (bvxor s26 t142))
				(t144 (bvand s26 t142))
				(c44 (bvor t170 t169))
				(t172 (bvxor s33 t171))
				(t173 (bvand s33 t171))
				(c52 (bvor t199 t198))
				(t201 (bvxor s40 t200))
				(t202 (bvand s40 t200))
				(t230 (bvxor s47 t229))
				(t231 (bvand s47 t229))
			)		
		(let
			(
				(s27 (bvxor c28 t114))
				(t116 (bvand c28 t114))
				(s34 (bvxor c36 t143))
				(t145 (bvand c36 t143))
				(s41 (bvxor c44 t172))
				(t174 (bvand c44 t172))
				(s48 (bvxor c52 t201))
				(t203 (bvand c52 t201))
				(s55 (bvxor c60 t230))
				(t232 (bvand c60 t230))
			)		
		(let
			(
				(c29 (bvor t116 t115))
				(c37 (bvor t145 t144))
				(t147 (bvxor s27 t146))
				(t148 (bvand s27 t146))
				(c45 (bvor t174 t173))
				(t176 (bvxor s34 t175))
				(t177 (bvand s34 t175))
				(c53 (bvor t203 t202))
				(t205 (bvxor s41 t204))
				(t206 (bvand s41 t204))
				(c61 (bvor t232 t231))
				(t234 (bvxor s48 t233))
				(t235 (bvand s48 t233))
				(p8 (bvxor s55 t265))
				(c70 (bvand s55 t265))
			)		
		(let
			(
				(s35 (bvxor c37 t147))
				(t149 (bvand c37 t147))
				(t151 (bvxor c29 t150))
				(t152 (bvand c29 t150))
				(s42 (bvxor c45 t176))
				(t178 (bvand c45 t176))
				(s49 (bvxor c53 t205))
				(t207 (bvand c53 t205))
				(s56 (bvxor c61 t234))
				(t236 (bvand c61 t234))
				(m8 (bvfa_sum p8 a8 c97))
				(c98 (bvfa_carry p8 a8 c97))
			)		
		(let
			(
				(c38 (bvor t149 t148))
				(c46 (bvor t178 t177))
				(t180 (bvxor s35 t179))
				(t181 (bvand s35 t179))
				(c54 (bvor t207 t206))
				(t209 (bvxor s42 t208))
				(t210 (bvand s42 t208))
				(c62 (bvor t236 t235))
				(t238 (bvxor s49 t237))
				(t239 (bvand s49 t237))
				(t267 (bvxor s56 t266))
				(t268 (bvand s56 t266))
			)		
		(let
			(
				(s36 (bvxor c38 t151))
				(t153 (bvand c38 t151))
				(s43 (bvxor c46 t180))
				(t182 (bvand c46 t180))
				(s50 (bvxor c54 t209))
				(t211 (bvand c54 t209))
				(s57 (bvxor c62 t238))
				(t240 (bvand c62 t238))
				(s64 (bvxor c70 t267))
				(t269 (bvand c70 t267))
			)		
		(let
			(
				(c39 (bvor t153 t152))
				(c47 (bvor t182 t181))
				(t184 (bvxor s36 t183))
				(t185 (bvand s36 t183))
				(c55 (bvor t211 t210))
				(t213 (bvxor s43 t212))
				(t214 (bvand s43 t212))
				(c63 (bvor t240 t239))
				(t242 (bvxor s50 t241))
				(t243 (bvand s50 t241))
				(c71 (bvor t269 t268))
				(t271 (bvxor s57 t270))
				(t272 (bvand s57 t270))
				(p9 (bvxor s64 t302))
				(c80 (bvand s64 t302))
			)		
		(let
			(
				(s44 (bvxor c47 t184))
				(t186 (bvand c47 t184))
				(t188 (bvxor c39 t187))
				(t189 (bvand c39 t187))
				(s51 (bvxor c55 t213))
				(t215 (bvand c55 t213))
				(s58 (bvxor c63 t242))
				(t244 (bvand c63 t242))
				(s65 (bvxor c71 t271))
				(t273 (bvand c71 t271))
				(m9 (bvfa_sum p9 a9 c98))
				(c99 (bvfa_carry p9 a9 c98))
			)		
		(let
			(
				(c48 (bvor t186 t185))
				(c56 (bvor t215 t214))
				(t217 (bvxor s44 t216))
				(t218 (bvand s44 t216))
				(c64 (bvor t244 t243))
				(t246 (bvxor s51 t245))
				(t247 (bvand s51 t245))
				(c72 (bvor t273 t272))
				(t275 (bvxor s58 t274))
				(t276 (bvand s58 t274))
				(t304 (bvxor s65 t303))
				(t305 (bvand s65 t303))
			)		
		(let
			(
				(s45 (bvxor c48 t188))
				(t190 (bvand c48 t188))
				(s52 (bvxor c56 t217))
				(t219 (bvand c56 t217))
				(s59 (bvxor c64 t246))
				(t248 (bvand c64 t246))
				(s66 (bvxor c72 t275))
				(t277 (bvand c72 t275))
				(p10 (bvxor c80 t304))
				(t306 (bvand c80 t304))
			)		
		(let
			(
				(c49 (bvor t190 t189))
				(c57 (bvor t219 t218))
				(t221 (bvxor s45 t220))
				(t222 (bvand s45 t220))
				(c65 (bvor t248 t247))
				(t250 (bvxor s52 t249))
				(t251 (bvand s52 t249))
				(c73 (bvor t277 t276))
				(t279 (bvxor s59 t278))
				(t280 (bvand s59 t278))
				(c81 (bvor t306 t305))
				(t308 (bvxor s66 t307))
				(t309 (bvand s66 t307))
				(m10 (bvfa_sum p10 a10 c99))
				(c100 (bvfa_carry p10 a10 c99))
			)		
		(let
			(
				(s53 (bvxor c57 t221))
				(t223 (bvand c57 t221))
				(t225 (bvxor c49 t224))
				(t226 (bvand c49 t224))
				(s60 (bvxor c65 t250))
				(t252 (bvand c65 t250))
				(s67 (bvxor c73 t279))
				(t281 (bvand c73 t279))
				(p11 (bvxor c81 t308))
				(t310 (bvand c81 t308))
			)		
		(let
			(
				(c58 (bvor t223 t222))
				(c66 (bvor t252 t251))
				(t254 (bvxor s53 t253))
				(t255 (bvand s53 t253))
				(c74 (bvor t281 t280))
				(t283 (bvxor s60 t282))
				(t284 (bvand s60 t282))
				(c82 (bvor t310 t309))
				(t312 (bvxor s67 t311))
				(t313 (bvand s67 t311))
				(m11 (bvfa_sum p11 a11 c100))
				(c101 (bvfa_carry p11 a11 c100))
			)		
		(let
			(
				(s54 (bvxor c58 t225))
				(t227 (bvand c58 t225))
				(s61 (bvxor c66 t254))
				(t256 (bvand c66 t254))
				(s68 (bvxor c74 t283))
				(t285 (bvand c74 t283))
				(p12 (bvxor c82 t312))
				(t314 (bvand c82 t312))
			)		
		(let
			(
				(c59 (bvor t227 t226))
				(c67 (bvor t256 t255))
				(t258 (bvxor s54 t257))
				(t259 (bvand s54 t257))
				(c75 (bvor t285 t284))
				(t287 (bvxor s61 t286))
				(t288 (bvand s61 t286))
				(c83 (bvor t314 t313))
				(t316 (bvxor s68 t315))
				(t317 (bvand s68 t315))
				(m12 (bvfa_sum p12 a12 c101))
				(c102 (bvfa_carry p12 a12 c101))
			)		
		(let
			(
				(s62 (bvxor c67 t258))
				(t260 (bvand c67 t258))
				(t262 (bvxor c59 t261))
				(t263 (bvand c59 t261))
				(s69 (bvxor c75 t287))
				(t289 (bvand c75 t287))
				(p13 (bvxor c83 t316))
				(t318 (bvand c83 t316))
			)		
		(let
			(
				(c68 (bvor t260 t259))
				(c76 (bvor t289 t288))
				(t291 (bvxor s62 t290))
				(t292 (bvand s62 t290))
				(c84 (bvor t318 t317))
				(t320 (bvxor s69 t319))
				(t321 (bvand s69 t319))
				(m13 (bvfa_sum p13 a13 c102))
				(c103 (bvfa_carry p13 a13 c102))
			)		
		(let
			(
				(s63 (bvxor c68 t262))
				(t264 (bvand c68 t262))
				(s70 (bvxor c76 t291))
				(t293 (bvand c76 t291))
				(p14 (bvxor c84 t320))
				(t322 (bvand c84 t320))
			)		
		(let
			(
				(c69 (bvor t264 t263))
				(c77 (bvor t293 t292))
				(t295 (bvxor s63 t294))
				(t296 (bvand s63 t294))
				(c85 (bvor t322 t321))
				(t324 (bvxor s70 t323))
				(t325 (bvand s70 t323))
				(m14 (bvfa_sum p14 a14 c103))
				(c104 (bvfa_carry p14 a14 c103))
			)		
		(let
			(
				(s71 (bvxor c77 t295))
				(t297 (bvand c77 t295))
				(t299 (bvxor c69 t298))
				(t300 (bvand c69 t298))
				(p15 (bvxor c85 t324))
				(t326 (bvand c85 t324))
			)		
		(let
			(
				(c78 (bvor t297 t296))
				(c86 (bvor t326 t325))
				(t328 (bvxor s71 t327))
				(t329 (bvand s71 t327))
				(m15 (bvfa_sum p15 a15 c104))
				(c105 (bvfa_carry p15 a15 c104))
			)		
		(let
			(
				(s72 (bvxor c78 t299))
				(t301 (bvand c78 t299))
				(p16 (bvxor c86 t328))
				(t330 (bvand c86 t328))
			)		
		(let
			(
				(c79 (bvor t301 t300))
				(c87 (bvor t330 t329))
				(t332 (bvxor s72 t331))
				(t333 (bvand s72 t331))
				(m16 (bvfa_sum p16 a16 c105))
				(c106 (bvfa_carry p16 a16 c105))
			)		
		(let
			(
				(p17 (bvxor c87 t332))
				(t334 (bvand c87 t332))
				(t336 (bvxor c79 t335))
				(t337 (bvand c79 t335))
			)		
		(let
			(
				(c88 (bvor t334 t333))
				(m17 (bvfa_sum p17 a17 c106))
				(c107 (bvfa_carry p17 a17 c106))
			)		
		(let
			(
				(p18 (bvxor c88 t336))
				(t338 (bvand c88 t336))
			)		
		(let
			(
				(p19 (bvor t338 t337))
				(m18 (bvfa_sum p18 a18 c107))
				(c108 (bvfa_carry p18 a18 c107))
			)		
		(let
			(
				(m19 (bvfa_sum p19 a19 c108))
				(c109 (bvfa_carry p19 a19 c108))
			)		
		(let
			(
				(a0_1 (bvRegD m0 (_ bv0 1)))
				(a1_1 (bvRegD m1 (_ bv0 1)))
				(a2_1 (bvRegD m2 (_ bv0 1)))
				(a3_1 (bvRegD m3 (_ bv0 1)))
				(a4_1 (bvRegD m4 (_ bv0 1)))
				(a5_1 (bvRegD m5 (_ bv0 1)))
				(a6_1 (bvRegD m6 (_ bv0 1)))
				(a7_1 (bvRegD m7 (_ bv0 1)))
				(a8_1 (bvRegD m8 (_ bv0 1)))
				(a9_1 (bvRegD m9 (_ bv0 1)))
				(a10_1 (bvRegD m10 (_ bv0 1)))
				(a11_1 (bvRegD m11 (_ bv0 1)))
				(a12_1 (bvRegD m12 (_ bv0 1)))
				(a13_1 (bvRegD m13 (_ bv0 1)))
				(a14_1 (bvRegD m14 (_ bv0 1)))
				(a15_1 (bvRegD m15 (_ bv0 1)))
				(a16_1 (bvRegD m16 (_ bv0 1)))
				(a17_1 (bvRegD m17 (_ bv0 1)))
				(a18_1 (bvRegD m18 (_ bv0 1)))
				(a19_1 (bvRegD m19 (_ bv0 1)))
			)
		(let
			(
				(out_pchb (concat a19_1 a18_1 a17_1 a16_1 a15_1 a14_1 a13_1 a12_1 a11_1 a10_1 a9_1 a8_1 a7_1 a6_1 a5_1 a4_1 a3_1 a2_1 a1_1 a0_1))
			)
				;        ------------------Sync Specification -------------------
		(let
			(
				(x_t (concat (_ bv0 10) x9 x8 x7 x6 x5 x4 x3 x2 x1 x0))
				(y_t (concat (_ bv0 10) y9 y8 y7 y6 y5 y4 y3 y2 y1 y0))
				(A (ite (= reset (_ bv1 1)) (_ bv0 20) A_cs))			
			)
		(let 
			(
				(z (bvmul x_t y_t))
			)
		(let 
			(
				(out_sync (bvadd z A))
			)
		(=>
			(and 
				(= reset (_ bv0 1)) (= A_cs (concat a19 a18 a17 a16 a15 a14 a13 a12 a11 a10 a9 a8 a7 a6 a5 a4 a3 a2 a1 a0)) 
			)
			(= out_pchb out_sync)	
		) )))))))))) )))))))))) )))))))))) )))))))))) )))))))))) ))))))))
	)
)
(check-sat)
(get-model)
