; Formal verification proof - functional equivalence checking of test_netlist_20+10x10MACfinal.txt
(set-logic QF_BV)

; Inputs: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, y0, y1, y2, y3, y4, y5, y6, y7, y8, y9
(declare-fun x0 () (_ BitVec 1))
(declare-fun x1 () (_ BitVec 1))
(declare-fun x2 () (_ BitVec 1))
(declare-fun x3 () (_ BitVec 1))
(declare-fun x4 () (_ BitVec 1))
(declare-fun x5 () (_ BitVec 1))
(declare-fun x6 () (_ BitVec 1))
(declare-fun x7 () (_ BitVec 1))
(declare-fun x8 () (_ BitVec 1))
(declare-fun x9 () (_ BitVec 1))
(declare-fun y0 () (_ BitVec 1))
(declare-fun y1 () (_ BitVec 1))
(declare-fun y2 () (_ BitVec 1))
(declare-fun y3 () (_ BitVec 1))
(declare-fun y4 () (_ BitVec 1))
(declare-fun y5 () (_ BitVec 1))
(declare-fun y6 () (_ BitVec 1))
(declare-fun y7 () (_ BitVec 1))
(declare-fun y8 () (_ BitVec 1))
(declare-fun y9 () (_ BitVec 1))

; Initial register output states of: a0, a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19
(declare-fun a0 () (_ BitVec 1))
(declare-fun a1 () (_ BitVec 1))
(declare-fun a2 () (_ BitVec 1))
(declare-fun a3 () (_ BitVec 1))
(declare-fun a4 () (_ BitVec 1))
(declare-fun a5 () (_ BitVec 1))
(declare-fun a6 () (_ BitVec 1))
(declare-fun a7 () (_ BitVec 1))
(declare-fun a8 () (_ BitVec 1))
(declare-fun a9 () (_ BitVec 1))
(declare-fun a10 () (_ BitVec 1))
(declare-fun a11 () (_ BitVec 1))
(declare-fun a12 () (_ BitVec 1))
(declare-fun a13 () (_ BitVec 1))
(declare-fun a14 () (_ BitVec 1))
(declare-fun a15 () (_ BitVec 1))
(declare-fun a16 () (_ BitVec 1))
(declare-fun a17 () (_ BitVec 1))
(declare-fun a18 () (_ BitVec 1))
(declare-fun a19 () (_ BitVec 1))

(declare-fun reset () (_ BitVec 1))
(declare-fun A_cs () (_ BitVec 20))


(define-fun bvRegD ((a (_ BitVec 1 )) (reset (_ BitVec 1))) (_ BitVec 1)						
 (ite (= reset (_ bv1 1)) (_ bv0 1) a) )


(define-fun bvha_sum ((a (_ BitVec 1 )) (b (_ BitVec 1 ))) (_ BitVec 1)						
 (bvxor a b) )

(define-fun bvha_carry ((a (_ BitVec 1 )) (b (_ BitVec 1 ))) (_ BitVec 1)						
 (bvand a b) )


(define-fun bvfa_sum ((a (_ BitVec 1 )) (b (_ BitVec 1 )) (cin (_ BitVec 1 )) ) (_ BitVec 1)						
 (bvxor a (bvxor b cin)) )

(define-fun bvfa_carry ((a (_ BitVec 1 )) (b (_ BitVec 1 )) (cin (_ BitVec 1 )) ) (_ BitVec 1)						
 (bvor (bvand a b) (bvor (bvand b cin) (bvand a cin)))  )

; SAT/UNSAT assertion for test_netlist_20+10x10MACfinal.txt
(assert
	(not		
		(let
			(
				(p0 (bvand x0 y0))
				(and0x1 (bvand x0 y1))
				(and0x2 (bvand x0 y2))
				(and0x3 (bvand x0 y3))
				(and0x4 (bvand x0 y4))
				(and0x5 (bvand x0 y5))
				(and0x6 (bvand x0 y6))
				(and0x7 (bvand x0 y7))
				(and0x8 (bvand x0 y8))
				(and0x9 (bvand x0 y9))
				(and1x0 (bvand x1 y0))
				(and1x1 (bvand x1 y1))
				(and1x2 (bvand x1 y2))
				(and1x3 (bvand x1 y3))
				(and1x4 (bvand x1 y4))
				(and1x5 (bvand x1 y5))
				(and1x6 (bvand x1 y6))
				(and1x7 (bvand x1 y7))
				(and1x8 (bvand x1 y8))
				(and1x9 (bvand x1 y9))
				(and2x0 (bvand x2 y0))
				(and2x1 (bvand x2 y1))
				(and2x2 (bvand x2 y2))
				(and2x3 (bvand x2 y3))
				(and2x4 (bvand x2 y4))
				(and2x5 (bvand x2 y5))
				(and2x6 (bvand x2 y6))
				(and2x7 (bvand x2 y7))
				(and2x8 (bvand x2 y8))
				(and2x9 (bvand x2 y9))
				(and3x0 (bvand x3 y0))
				(and3x1 (bvand x3 y1))
				(and3x2 (bvand x3 y2))
				(and3x3 (bvand x3 y3))
				(and3x4 (bvand x3 y4))
				(and3x5 (bvand x3 y5))
				(and3x6 (bvand x3 y6))
				(and3x7 (bvand x3 y7))
				(and3x8 (bvand x3 y8))
				(and3x9 (bvand x3 y9))
				(and4x0 (bvand x4 y0))
				(and4x1 (bvand x4 y1))
				(and4x2 (bvand x4 y2))
				(and4x3 (bvand x4 y3))
				(and4x4 (bvand x4 y4))
				(and4x5 (bvand x4 y5))
				(and4x6 (bvand x4 y6))
				(and4x7 (bvand x4 y7))
				(and4x8 (bvand x4 y8))
				(and4x9 (bvand x4 y9))
				(and5x0 (bvand x5 y0))
				(and5x1 (bvand x5 y1))
				(and5x2 (bvand x5 y2))
				(and5x3 (bvand x5 y3))
				(and5x4 (bvand x5 y4))
				(and5x5 (bvand x5 y5))
				(and5x6 (bvand x5 y6))
				(and5x7 (bvand x5 y7))
				(and5x8 (bvand x5 y8))
				(and5x9 (bvand x5 y9))
				(and6x0 (bvand x6 y0))
				(and6x1 (bvand x6 y1))
				(and6x2 (bvand x6 y2))
				(and6x3 (bvand x6 y3))
				(and6x4 (bvand x6 y4))
				(and6x5 (bvand x6 y5))
				(and6x6 (bvand x6 y6))
				(and6x7 (bvand x6 y7))
				(and6x8 (bvand x6 y8))
				(and6x9 (bvand x6 y9))
				(and7x0 (bvand x7 y0))
				(and7x1 (bvand x7 y1))
				(and7x2 (bvand x7 y2))
				(and7x3 (bvand x7 y3))
				(and7x4 (bvand x7 y4))
				(and7x5 (bvand x7 y5))
				(and7x6 (bvand x7 y6))
				(and7x7 (bvand x7 y7))
				(and7x8 (bvand x7 y8))
				(and7x9 (bvand x7 y9))
				(and8x0 (bvand x8 y0))
				(and8x1 (bvand x8 y1))
				(and8x2 (bvand x8 y2))
				(and8x3 (bvand x8 y3))
				(and8x4 (bvand x8 y4))
				(and8x5 (bvand x8 y5))
				(and8x6 (bvand x8 y6))
				(and8x7 (bvand x8 y7))
				(and8x8 (bvand x8 y8))
				(and8x9 (bvand x8 y9))
				(and9x0 (bvand x9 y0))
				(and9x1 (bvand x9 y1))
				(and9x2 (bvand x9 y2))
				(and9x3 (bvand x9 y3))
				(and9x4 (bvand x9 y4))
				(and9x5 (bvand x9 y5))
				(and9x6 (bvand x9 y6))
				(and9x7 (bvand x9 y7))
				(and9x8 (bvand x9 y8))
				(and9x9 (bvand x9 y9))
			)		
		(let
			(
				(p1 (bvha_sum and0x1 and1x0))
				(c1x1 (bvha_carry and0x1 and1x0))
				(m0 (bvha_sum p0 a0))
				(c90 (bvha_carry p0 a0))
			)		
		(let
			(
				(s1x2 (bvfa_sum and2x0 and1x1 c1x1))
				(c1x2 (bvfa_carry and2x0 and1x1 c1x1))
				(m1 (bvfa_sum p1 a1 c90))
				(c91 (bvfa_carry p1 a1 c90))
			)		
		(let
			(
				(s1x3 (bvfa_sum and3x0 and2x1 c1x2))
				(c1x3 (bvfa_carry and3x0 and2x1 c1x2))
				(p2 (bvha_sum and0x2 s1x2))
				(c2x2 (bvha_carry and0x2 s1x2))
			)		
		(let
			(
				(s1x4 (bvfa_sum and4x0 and3x1 c1x3))
				(c1x4 (bvfa_carry and4x0 and3x1 c1x3))
				(s2x3 (bvfa_sum and1x2 s1x3 c2x2))
				(c2x3 (bvfa_carry and1x2 s1x3 c2x2))
				(m2 (bvfa_sum p2 a2 c91))
				(c92 (bvfa_carry p2 a2 c91))
			)		
		(let
			(
				(s1x5 (bvfa_sum and5x0 and4x1 c1x4))
				(c1x5 (bvfa_carry and5x0 and4x1 c1x4))
				(s2x4 (bvfa_sum and2x2 s1x4 c2x3))
				(c2x4 (bvfa_carry and2x2 s1x4 c2x3))
				(p3 (bvha_sum and0x3 s2x3))
				(c3x3 (bvha_carry and0x3 s2x3))
			)		
		(let
			(
				(s1x6 (bvfa_sum and6x0 and5x1 c1x5))
				(c1x6 (bvfa_carry and6x0 and5x1 c1x5))
				(s2x5 (bvfa_sum and3x2 s1x5 c2x4))
				(c2x5 (bvfa_carry and3x2 s1x5 c2x4))
				(s3x4 (bvfa_sum and1x3 s2x4 c3x3))
				(c3x4 (bvfa_carry and1x3 s2x4 c3x3))
				(m3 (bvfa_sum p3 a3 c92))
				(c93 (bvfa_carry p3 a3 c92))
			)		
		(let
			(
				(s1x7 (bvfa_sum and7x0 and6x1 c1x6))
				(c1x7 (bvfa_carry and7x0 and6x1 c1x6))
				(s2x6 (bvfa_sum and4x2 s1x6 c2x5))
				(c2x6 (bvfa_carry and4x2 s1x6 c2x5))
				(s3x5 (bvfa_sum and2x3 s2x5 c3x4))
				(c3x5 (bvfa_carry and2x3 s2x5 c3x4))
				(p4 (bvha_sum and0x4 s3x4))
				(c4x4 (bvha_carry and0x4 s3x4))
			)		
		(let
			(
				(s1x8 (bvfa_sum and8x0 and7x1 c1x7))
				(c1x8 (bvfa_carry and8x0 and7x1 c1x7))
				(s2x7 (bvfa_sum and5x2 s1x7 c2x6))
				(c2x7 (bvfa_carry and5x2 s1x7 c2x6))
				(s3x6 (bvfa_sum and3x3 s2x6 c3x5))
				(c3x6 (bvfa_carry and3x3 s2x6 c3x5))
				(s4x5 (bvfa_sum and1x4 s3x5 c4x4))
				(c4x5 (bvfa_carry and1x4 s3x5 c4x4))
				(m4 (bvfa_sum p4 a4 c93))
				(c94 (bvfa_carry p4 a4 c93))
			)		
		(let
			(
				(s1x9 (bvfa_sum and9x0 and8x1 c1x8))
				(c1x9 (bvfa_carry and9x0 and8x1 c1x8))
				(s2x8 (bvfa_sum and6x2 s1x8 c2x7))
				(c2x8 (bvfa_carry and6x2 s1x8 c2x7))
				(s3x7 (bvfa_sum and4x3 s2x7 c3x6))
				(c3x7 (bvfa_carry and4x3 s2x7 c3x6))
				(s4x6 (bvfa_sum and2x4 s3x6 c4x5))
				(c4x6 (bvfa_carry and2x4 s3x6 c4x5))
				(p5 (bvha_sum and0x5 s4x5))
				(c5x5 (bvha_carry and0x5 s4x5))
			)		
		(let
			(
				(s2x9 (bvfa_sum and7x2 s1x9 c2x8))
				(c2x9 (bvfa_carry and7x2 s1x9 c2x8))
				(s3x8 (bvfa_sum and5x3 s2x8 c3x7))
				(c3x8 (bvfa_carry and5x3 s2x8 c3x7))
				(s4x7 (bvfa_sum and3x4 s3x7 c4x6))
				(c4x7 (bvfa_carry and3x4 s3x7 c4x6))
				(s5x6 (bvfa_sum and1x5 s4x6 c5x5))
				(c5x6 (bvfa_carry and1x5 s4x6 c5x5))
				(m5 (bvfa_sum p5 a5 c94))
				(c95 (bvfa_carry p5 a5 c94))
			)		
		(let
			(
				(s2x10 (bvfa_sum and9x1 c1x9 c2x9))
				(c2x10 (bvfa_carry and9x1 c1x9 c2x9))
				(s3x9 (bvfa_sum and6x3 s2x9 c3x8))
				(c3x9 (bvfa_carry and6x3 s2x9 c3x8))
				(s4x8 (bvfa_sum and4x4 s3x8 c4x7))
				(c4x8 (bvfa_carry and4x4 s3x8 c4x7))
				(s5x7 (bvfa_sum and2x5 s4x7 c5x6))
				(c5x7 (bvfa_carry and2x5 s4x7 c5x6))
				(p6 (bvha_sum and0x6 s5x6))
				(c6x6 (bvha_carry and0x6 s5x6))
			)		
		(let
			(
				(s3x10 (bvfa_sum and8x2 s2x10 c3x9))
				(c3x10 (bvfa_carry and8x2 s2x10 c3x9))
				(s4x9 (bvfa_sum and5x4 s3x9 c4x8))
				(c4x9 (bvfa_carry and5x4 s3x9 c4x8))
				(s5x8 (bvfa_sum and3x5 s4x8 c5x7))
				(c5x8 (bvfa_carry and3x5 s4x8 c5x7))
				(s6x7 (bvfa_sum and1x6 s5x7 c6x6))
				(c6x7 (bvfa_carry and1x6 s5x7 c6x6))
				(m6 (bvfa_sum p6 a6 c95))
				(c96 (bvfa_carry p6 a6 c95))
			)		
		(let
			(
				(s3x11 (bvfa_sum and9x2 c2x10 c3x10))
				(c3x11 (bvfa_carry and9x2 c2x10 c3x10))
				(s4x10 (bvfa_sum and7x3 s3x10 c4x9))
				(c4x10 (bvfa_carry and7x3 s3x10 c4x9))
				(s5x9 (bvfa_sum and4x5 s4x9 c5x8))
				(c5x9 (bvfa_carry and4x5 s4x9 c5x8))
				(s6x8 (bvfa_sum and2x6 s5x8 c6x7))
				(c6x8 (bvfa_carry and2x6 s5x8 c6x7))
				(p7 (bvha_sum and0x7 s6x7))
				(c7x7 (bvha_carry and0x7 s6x7))
			)		
		(let
			(
				(s4x11 (bvfa_sum and8x3 s3x11 c4x10))
				(c4x11 (bvfa_carry and8x3 s3x11 c4x10))
				(s5x10 (bvfa_sum and6x4 s4x10 c5x9))
				(c5x10 (bvfa_carry and6x4 s4x10 c5x9))
				(s6x9 (bvfa_sum and3x6 s5x9 c6x8))
				(c6x9 (bvfa_carry and3x6 s5x9 c6x8))
				(s7x8 (bvfa_sum and1x7 s6x8 c7x7))
				(c7x8 (bvfa_carry and1x7 s6x8 c7x7))
				(m7 (bvfa_sum p7 a7 c96))
				(c97 (bvfa_carry p7 a7 c96))
			)		
		(let
			(
				(s4x12 (bvfa_sum and9x3 c3x11 c4x11))
				(c4x12 (bvfa_carry and9x3 c3x11 c4x11))
				(s5x11 (bvfa_sum and7x4 s4x11 c5x10))
				(c5x11 (bvfa_carry and7x4 s4x11 c5x10))
				(s6x10 (bvfa_sum and5x5 s5x10 c6x9))
				(c6x10 (bvfa_carry and5x5 s5x10 c6x9))
				(s7x9 (bvfa_sum and2x7 s6x9 c7x8))
				(c7x9 (bvfa_carry and2x7 s6x9 c7x8))
				(p8 (bvha_sum and0x8 s7x8))
				(c8x8 (bvha_carry and0x8 s7x8))
			)		
		(let
			(
				(s5x12 (bvfa_sum and8x4 s4x12 c5x11))
				(c5x12 (bvfa_carry and8x4 s4x12 c5x11))
				(s6x11 (bvfa_sum and6x5 s5x11 c6x10))
				(c6x11 (bvfa_carry and6x5 s5x11 c6x10))
				(s7x10 (bvfa_sum and4x6 s6x10 c7x9))
				(c7x10 (bvfa_carry and4x6 s6x10 c7x9))
				(s8x9 (bvfa_sum and1x8 s7x9 c8x8))
				(c8x9 (bvfa_carry and1x8 s7x9 c8x8))
				(m8 (bvfa_sum p8 a8 c97))
				(c98 (bvfa_carry p8 a8 c97))
			)		
		(let
			(
				(s5x13 (bvfa_sum and9x4 c4x12 c5x12))
				(c5x13 (bvfa_carry and9x4 c4x12 c5x12))
				(s6x12 (bvfa_sum and7x5 s5x12 c6x11))
				(c6x12 (bvfa_carry and7x5 s5x12 c6x11))
				(s7x11 (bvfa_sum and5x6 s6x11 c7x10))
				(c7x11 (bvfa_carry and5x6 s6x11 c7x10))
				(s8x10 (bvfa_sum and3x7 s7x10 c8x9))
				(c8x10 (bvfa_carry and3x7 s7x10 c8x9))
				(p9 (bvha_sum and0x9 s8x9))
				(c9x9 (bvha_carry and0x9 s8x9))
			)		
		(let
			(
				(s6x13 (bvfa_sum and8x5 s5x13 c6x12))
				(c6x13 (bvfa_carry and8x5 s5x13 c6x12))
				(s7x12 (bvfa_sum and6x6 s6x12 c7x11))
				(c7x12 (bvfa_carry and6x6 s6x12 c7x11))
				(s8x11 (bvfa_sum and4x7 s7x11 c8x10))
				(c8x11 (bvfa_carry and4x7 s7x11 c8x10))
				(s9x10 (bvfa_sum and2x8 s8x10 c9x9))
				(c9x10 (bvfa_carry and2x8 s8x10 c9x9))
				(m9 (bvfa_sum p9 a9 c98))
				(c99 (bvfa_carry p9 a9 c98))
			)		
		(let
			(
				(s6x14 (bvfa_sum and9x5 c5x13 c6x13))
				(c6x14 (bvfa_carry and9x5 c5x13 c6x13))
				(s7x13 (bvfa_sum and7x6 s6x13 c7x12))
				(c7x13 (bvfa_carry and7x6 s6x13 c7x12))
				(s8x12 (bvfa_sum and5x7 s7x12 c8x11))
				(c8x12 (bvfa_carry and5x7 s7x12 c8x11))
				(s9x11 (bvfa_sum and3x8 s8x11 c9x10))
				(c9x11 (bvfa_carry and3x8 s8x11 c9x10))
				(p10 (bvha_sum and1x9 s9x10))
				(c10x10 (bvha_carry and1x9 s9x10))
			)		
		(let
			(
				(s7x14 (bvfa_sum and8x6 s6x14 c7x13))
				(c7x14 (bvfa_carry and8x6 s6x14 c7x13))
				(s8x13 (bvfa_sum and6x7 s7x13 c8x12))
				(c8x13 (bvfa_carry and6x7 s7x13 c8x12))
				(s9x12 (bvfa_sum and4x8 s8x12 c9x11))
				(c9x12 (bvfa_carry and4x8 s8x12 c9x11))
				(p11 (bvfa_sum and2x9 s9x11 c10x10))
				(c10x11 (bvfa_carry and2x9 s9x11 c10x10))
				(m10 (bvfa_sum p10 a10 c99))
				(c100 (bvfa_carry p10 a10 c99))
			)		
		(let
			(
				(s7x15 (bvfa_sum and9x6 c6x14 c7x14))
				(c7x15 (bvfa_carry and9x6 c6x14 c7x14))
				(s8x14 (bvfa_sum and7x7 s7x14 c8x13))
				(c8x14 (bvfa_carry and7x7 s7x14 c8x13))
				(s9x13 (bvfa_sum and5x8 s8x13 c9x12))
				(c9x13 (bvfa_carry and5x8 s8x13 c9x12))
				(p12 (bvfa_sum and3x9 s9x12 c10x11))
				(c10x12 (bvfa_carry and3x9 s9x12 c10x11))
				(m11 (bvfa_sum p11 a11 c100))
				(c101 (bvfa_carry p11 a11 c100))
			)		
		(let
			(
				(s8x15 (bvfa_sum and8x7 s7x15 c8x14))
				(c8x15 (bvfa_carry and8x7 s7x15 c8x14))
				(s9x14 (bvfa_sum and6x8 s8x14 c9x13))
				(c9x14 (bvfa_carry and6x8 s8x14 c9x13))
				(p13 (bvfa_sum and4x9 s9x13 c10x12))
				(c10x13 (bvfa_carry and4x9 s9x13 c10x12))
				(m12 (bvfa_sum p12 a12 c101))
				(c102 (bvfa_carry p12 a12 c101))
			)		
		(let
			(
				(s8x16 (bvfa_sum and9x7 c7x15 c8x15))
				(c8x16 (bvfa_carry and9x7 c7x15 c8x15))
				(s9x15 (bvfa_sum and7x8 s8x15 c9x14))
				(c9x15 (bvfa_carry and7x8 s8x15 c9x14))
				(p14 (bvfa_sum and5x9 s9x14 c10x13))
				(c10x14 (bvfa_carry and5x9 s9x14 c10x13))
				(m13 (bvfa_sum p13 a13 c102))
				(c103 (bvfa_carry p13 a13 c102))
			)		
		(let
			(
				(s9x16 (bvfa_sum and8x8 s8x16 c9x15))
				(c9x16 (bvfa_carry and8x8 s8x16 c9x15))
				(p15 (bvfa_sum and6x9 s9x15 c10x14))
				(c10x15 (bvfa_carry and6x9 s9x15 c10x14))
				(m14 (bvfa_sum p14 a14 c103))
				(c104 (bvfa_carry p14 a14 c103))
			)		
		(let
			(
				(s9x17 (bvfa_sum and9x8 c8x16 c9x16))
				(c9x17 (bvfa_carry and9x8 c8x16 c9x16))
				(p16 (bvfa_sum and7x9 s9x16 c10x15))
				(c10x16 (bvfa_carry and7x9 s9x16 c10x15))
				(m15 (bvfa_sum p15 a15 c104))
				(c105 (bvfa_carry p15 a15 c104))
			)		
		(let
			(
				(p17 (bvfa_sum and8x9 s9x17 c10x16))
				(c10x17 (bvfa_carry and8x9 s9x17 c10x16))
				(m16 (bvfa_sum p16 a16 c105))
				(c106 (bvfa_carry p16 a16 c105))
			)		
		(let
			(
				(p18 (bvfa_sum and9x9 c9x17 c10x17))
				(p19 (bvfa_carry and9x9 c9x17 c10x17))
				(m17 (bvfa_sum p17 a17 c106))
				(c107 (bvfa_carry p17 a17 c106))
			)		
		(let
			(
				(m18 (bvfa_sum p18 a18 c107))
				(c108 (bvfa_carry p18 a18 c107))
			)		
		(let
			(
				(m19 (bvfa_sum p19 a19 c108))
				(c109 (bvfa_carry p19 a19 c108))
			)		
		(let
			(
				(a0_1 (bvRegD m0 (_ bv0 1)))
				(a1_1 (bvRegD m1 (_ bv0 1)))
				(a2_1 (bvRegD m2 (_ bv1 1)))
				(a3_1 (bvRegD m3 (_ bv0 1)))
				(a4_1 (bvRegD m4 (_ bv0 1)))
				(a5_1 (bvRegD m5 (_ bv0 1)))
				(a6_1 (bvRegD m6 (_ bv0 1)))
				(a7_1 (bvRegD m7 (_ bv0 1)))
				(a8_1 (bvRegD m8 (_ bv0 1)))
				(a9_1 (bvRegD m9 (_ bv0 1)))
				(a10_1 (bvRegD m10 (_ bv0 1)))
				(a11_1 (bvRegD m11 (_ bv0 1)))
				(a12_1 (bvRegD m12 (_ bv0 1)))
				(a13_1 (bvRegD m13 (_ bv0 1)))
				(a14_1 (bvRegD m14 (_ bv0 1)))
				(a15_1 (bvRegD m15 (_ bv0 1)))
				(a16_1 (bvRegD m16 (_ bv0 1)))
				(a17_1 (bvRegD m17 (_ bv0 1)))
				(a18_1 (bvRegD m18 (_ bv0 1)))
				(a19_1 (bvRegD m19 (_ bv0 1)))
			)
		(let
			(
				(out_pchb (concat a19_1 a18_1 a17_1 a16_1 a15_1 a14_1 a13_1 a12_1 a11_1 a10_1 a9_1 a8_1 a7_1 a6_1 a5_1 a4_1 a3_1 a2_1 a1_1 a0_1))
			)
				;        ------------------Sync Specification -------------------
		(let
			(
				(x_t (concat (_ bv0 10) x9 x8 x7 x6 x5 x4 x3 x2 x1 x0))
				(y_t (concat (_ bv0 10) y9 y8 y7 y6 y5 y4 y3 y2 y1 y0))
				(A (ite (= reset (_ bv1 1)) (_ bv0 20) A_cs))			
			)
		(let 
			(
				(z (bvmul x_t y_t))
			)
		(let 
			(
				(out_sync (bvadd z A))
			)
		(=>
			(and 
				(= reset (_ bv0 1)) (= A_cs (concat a19 a18 a17 a16 a15 a14 a13 a12 a11 a10 a9 a8 a7 a6 a5 a4 a3 a2 a1 a0)) 
			)
			(= out_pchb out_sync)	
		) )))))))))) )))))))))) )))))))))) )))))
	)
)			
(check-sat)
(get-model)
